'****************************************************************
'*  Name    : Test2_ReadSyncWrite.BAS                           *
'*  Author  : [Alberto Freixanet]                               *
'*  Notice  : Copyright (c) 2016 [AFreixanet]                   *
'*          : All Rights Reserved                               *
'*  Date    : 22/05/2016                                        *
'*  Version : 1.0                                               *
'*  Notes   : testing "ReadSyncWrite1.inc" library 4mS timing   *
'*          : or the "ReadSyncWrite2.inc" library 1mS timing    *
'*          : by TIMER2                                         *
'*          : Code written for the Amicus18 Board 18F25K20/K22  *
'*  Code powered by the Proton Development Suite Version 3583   *
'****************************************************************
'
'
'===============================================================================
' This program is free software, you can redistribute it and/or modify.
' The code is offered as-is and the author take any responsibility for its use.
' This program is distributed in the hope that it will be useful, but WITHOUT ANY
' WARRANTY. However, a mention of the author and compiler would be appreciated.
'
' Este programa es un software libre, puede redistribuirlo y/o modificarlo.
' Se entrega este cdigo tal como esta y el autor NO se hace responsable de
' su utilizacin. Este programa se distribuye con la esperanza de que sea til,
' pero SIN NINGUNA GARANTA. No obstante citar el autor y el compilador
' sera muy apreciado.

' Ce programme est un logiciel libre, vous pouvez le redistribuer et/ou modifier.
' Ce logiciel est offert tel qu'il est, et son auteur NE prend AUCUNE responsabilit
' pour son utilization. Ce programme est distribu dans l'espoir qu'il sera util,
' mais SANS AUCUNE GARANTIE. Cependant mentionner l'auteur et le compileur serait
' aprci.
'===============================================================================
'===============================================================================
' Uncomment this line to run the code with Proteus.
'    $define _ProteusDebug_

' Uncomment this line to test the WatchDog (disable the "Clrwdt" in the interrupt delay).
' The "$define WatchDog_On" line must be uncomment.
'    $define _TestWatchDogReset_

' Uncomment this line to enable the WatchDog.
    $define WatchDog_On

' Uncomment this line to use the oscilloscope to see the interrupt pulses. (only for this demo).
    $define _DebugInterrupt_
                                                                             
' Uncomment this Line To use the 4 mS timing, otherwize 1 mS timing.
    $define _LibraryTiming4MS_

'===============================================================================
'===============================================================================
' CHOOSE ONE OF THE 2 FILES FOR PIC18F25K20 OR PIC18F25K22.
'
'    Include "D:\MyIncFiles\Amicus18_25k20_WDT.inc"
    Include "Amicus18_25k20_WDT.inc"

'    Include "D:\MyIncFiles\Amicus18_25K22_WDT.inc"
'    Include "Amicus18_25k22_WDT.Inc"
'-------------------------------------------------------------------------------
' The compiler does not include "Clrwdt" in the command codes.
' The "Clrwdt" must to be managed by the user in the main code only.
    Declare Watchdog = OFF
    Declare Bootloader = On     ' goto proton#main#start, position error?????
'-------------------------------------------------------------------------------
    $if _device = _18F25K20
'    Include "D:\MyIncFiles\SYS_18Fxxk20.inc"
    Include "SYS_18Fxxk20.inc"
    $endif
    $if _device = _18F25K22
'    Include "D:\MyIncFiles\SYS_18F2X-4xk22.inc"
    Include "SYS_18F2X-4xk22.Inc"
    $endif
'-------------------------------------------------------------------------------
' Pins definitions of the project.
'    Include "D:\MyIncFiles\Project1002_Def.lpb"
    Include "Project1002_Def.lpb"
'-------------------------------------------------------------------------------
' Include the new library for Debounce/Watchdog & Read Syncronize Write library.   
    $ifdef _LibraryTiming4MS_
    ' LIBRARY WITH 4 MS TIMING WITH 2 PHASES FOR OUTPUTS
'    Include "D:\MyIncFiles\ReadSyncWrite2.Inc"
    Include "ReadSyncWrite2.inc"    
    $else
    ' LIBRARY WITH 1 MS TIMING WITH 2 PHASES For OUTPUTS
'    Include "D:\MyIncFiles\ReadSyncWrite4.Inc"
    Include "ReadSyncWrite4.inc"
    $endif
'===============================================================================
'*******************************************************************************    
' Declare some variables for main code.
    Dim LoopCounter As Byte
    Dim DataByte As Byte
'*******************************************************************************    
MAIN_TEST:
    $ifdef WatchDog_On
    If WDT_Detected = 1 Then
        HRSOut "WATCHDOG RESET DETECTED", CR
        DataWord = ERead ADD_WDT_COUNTER                    ' Read the value of the Watchdog counter saved in the eeprom.
        HRSOut "WATCHDOG COUNTER: ", Dec DataWord, CR, CR
    EndIf
    $endif

    ' INTERRUPTS DISABLED:
    ' The watchdog timer is set to 256mS by Config Fuses and running.
    ' Delay 1 second to start the project.
    ' It is the way to write a large delay when the Interrupts are not enabled yet.
    LoopCounter = 10            ' Load a 0,5 second delay.
    Repeat
        $ifdef WatchDog_On
        Clrwdt
        $endif
        Dec LoopCounter
        DelayMS 50              ' The Watchdog timer is running with a 256mS delay (configured in the Config Fuses).
    Until LoopCounter = 0
'-------------------------------------------------------------------------------
    ' INTERRUPTS DISABLED:
    INTCON2 = %10000000     ' PORTB Pullups disabled
    INTCON3 = 0
    PIR2 = 0
    PIE2 = 0
    IPR2 = 0                    
'
' Declare all digital   
    ADCON0 = 0
    ADCON1 = 15
    ADCON2 = 0    
    CM1CON0 = 0
    CM2CON0 = 0
    CM2CON1 = 0    
' The ANSEL pins are managed by the library.
'    ANSEL = 0
'    ANSELH = 0
'
' Init the eeprom
    EECON1 = 0
'
' Init the PORTS
    RELAY0 = 0
    RELAY1 = 0    
    RELAY2 = 0    
    RELAY3 = 0

    LED4 = 0
    LED5 = 0 
    LED6 = 0
    LED7 = 0       
      
' Pin for test.
$ifdef _DebugInterrupt_
    $if _device = _18F25K20
    ANSEL.4 = 0             ' Test pin to digital for PORTA.5
    $endif
    $if _device = _18F25K22
    ANSELA.5 = 0            ' Test pin to digital for PORTA.5
    ANSELC.5 = 0            ' Test pin to digital for PORTC.5
    $endif    
    Output OutTest          ' Test pin to output.
    Output OutTest1         ' Test pin to output.
    Output OutTest2         ' Test pin to output.
$endif
'-------------------------------------------------------------------------------
    ' INTERRUPTS DISABLED:
    ' Send all version files to the terminal.
    $ifdef _HRSOutVersionFile_inc_
    $ifdef WatchDog_On
    Clrwdt
    $endif
    HRSOut CR
    HRSOutVersionFile(_Project_Def_lpb_Version_)    ' Project001_Def.lpb
    HRSOutVersionFile(_VersionFile_inc_Version_)    ' VersionFile.inc
    HRSOutVersionFile(_ReadSyncWrite_inc_Version_)  ' Library .inc.
    HRSOutVersionFile(_ReadSyncWrite_bas_Version_)  ' Test main code .bas.
    $endif

    HRSOut "AMICUS18 BOARD "
    $if _device = _18F25K20
    HRSOut "Device: PIC18F25K20", CR
    $endif
    $if _device = _18F25K22
    HRSOut "Device: PIC18F25K22", CR
    $endif
    HRSOut CR  
'-------------------------------------------------------------------------------
STARTING_TEST:
    $ifdef WatchDog_On
    Clrwdt
    $endif
    HRSOut "READ SYNCRONIZES WRITE by A. Freixanet", CR
    HRSOut "DEBOUNCE 8 BUTTONS, RUN NEW WATCHDOG & WRITE BETWEEN READ", CR   

    '---------------------------------------------------------------------------
' The value of the DebounceRate must be a multiple of 8 (enter value minimum 16). Example: 16,24,32,40,48,56,64,72,80,88
' 96,104,112,120,128,136,144,152,160,168,176,184,192,200,208,216,224,232,240,248
'
' Configure the input pins to read every 16 mS. Stable input in 16 x 4 = 64 mS.
'
' Set the timing for the debonce routine. (the user must to change it)
'
' First example:
'    InitDebounceRate(Debounce Rate (16 to 248), Shift value(Value Timing), Shift direction(0=Right, 1=Left))
' - Debounce Ratec: Multiple of 8, (16 To 248)
' - Shift value: Timing 1 mS then Shift = 1mS x Value
' - Shift direction: If = 0 the write PORTs is in the middle of 2 readinds.
'
    InitDebounceRate(32,2,1) 
'   InitDebounceRate(Debounce every 32x4= 128mS), Shift value(2x1mS= 2Ms), Shift Left)
'
' Second example:
'    InitDebounceRate(32,0,0) 
'   InitDebounceRate(Debounce every 32x4=128mS), Shift value(0mS), Direction NO effect)
'
    ' INTERRUPTS ENABLED:
    ' Debouncing the buttons at 32mS x 4 samples = 128 mS
    ' After this command the Interrupts are started.
    '---------------------------------------------------------------------------
    DataByte = DebounceTimingTrigg * TimingRead
    HRSOut "DEBOUNCE RATE: ", Dec DataByte, " mS", 13
    HRSOut "DebounceTimingTrigg: ", Dec DebounceTimingTrigg, CR
    HRSOut "WriteTimingTrigg: ", Dec WriteTimingTrigg, CR
    HRSOut "WriteRelayTimingTrigg: ", Dec WriteRelayTimingTrigg, CR
    HRSOut CR

    ' Read the the watchdog counter and print it.
    $ifdef WatchDog_On
    DataWord = ERead ADD_WDT_COUNTER
    HRSOut "WDT COUNTER: ", Dec DataWord, CR
    $endif

    HRSOut "THE FOSC IS ", Dec _xtal, " Mhz", CR, CR
    HRSOut "PRESS THE BUTTON SW0 TO BEGIN...", CR, CR
    '---------------------------------------------------------------------------
WAITING_BUTTON:
    ' INTERRUPTS ENABLED:
    ' Waiting to press the SW0 button to continue.
    While 1 = 1
        If SW0_Fedge = 1 Then                   ' Check the falling edge of the input.
            SW0_Fedge = 0                       ' Clear the bit when it is already read.
            HRSOut "STARTING THE TEST", CR
            HRSOut "PRESS A BUTTON...", CR
            While SW0 = 0
                'Using the PDS Delay it is necessary to use the "Clrwdt instruction".
                $ifdef WatchDog_On
                Clrwdt
                $endif
                DelayMS 20      ' 20mS PDS delay
            Wend
            HRSOut CR
            Break               ' Exit the While/Wend loop, when the button is depressed.
        EndIf
        ' Without the delay enable these lines
        '$ifdef WatchDog_On
        'Clrwdt
        '$endif
        MyDelayMS(40)                           ' 40mS delay.
    Wend
    '
    '---------------------------------------------------------------------------
MAINLOOP:
    ' Running the main code.
    ' INTERRUPTS ENABLED:
    While 1 = 1
        ' Without the delay enable these lines
'        $ifdef WatchDog_On
'        Clrwdt
'        $endif

        ' Check all buttons pressed.
        ' Resistors pull-up to VDD
'        If SW0 = 0 Then
'            HRSOut "SW0 pressed!", CR    
'        EndIf
'        If SW1 = 0 Then
'            HRSOut "SW1 pressed!", CR    
'        EndIf    
'        If SW2 = 0 Then
'            HRSOut "SW2 pressed!", CR    
'        EndIf    
'        If SW3 = 0 Then
'            HRSOut "SW3 pressed!", CR    
'        EndIf    
        '
        ' Resistors pull-up To VSS
'        If SW4 = 1 Then
'            HRSOut "SW4 pressed!", CR    
'        EndIf
'        If SW5 = 1 Then
'            HRSOut "SW5 pressed!", CR    
'        EndIf    
'        If SW6 = 1 Then
'            HRSOut "SW6 pressed!", CR    
'        EndIf    
'        If SW7 = 1 Then
'            HRSOut "SW7 pressed!", CR    
'        EndIf     

        ' The events must to be clear by the user (bit by bit) after read it.
        ' Using the falling edge of the buttons. (see the schematic)
        ' Resistors pull-up to VDD
        If SW0_Fedge = 1 Then                   
            SW0_Fedge = 0                       ' Clear the bit when it is already read.
            HRSOut "Falling Detect SW0", CR
            
            'ClearRELWriteReadyFlag()
            'Toggle RELAY0                         ' Toggle the LED0 (Virtual pin) every time the SW0 is pressed.
            'WaitRELWriteReady()                   ' Waiting until the pin will be written.
            
            ' New command, samme as above.
            Toggle_RELAY(RELAY0)            
            ' OR
            'Set_RELAY(RELAY0)
            ' Or
            'Clear_RELAY(RELAY0)
            
            If RELAY0_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "RELAY0 ON", CR
            Else
                HRSOut "RELAY0 OFF", CR
            EndIf
            HRSOut CR
        EndIf

        If SW1_Fedge = 1 Then                   
            SW1_Fedge = 0                       ' Clear the bit when it is already read.
            HRSOut "Falling Detect SW1", CR

            'ClearRELWriteReadyFlag()
            'Toggle RELAY1                       ' Toggle the LED1 (Virtual pin) every time the SW1 is pressed.
            'WaitRELWriteReady()

            ' New command, samme as above.
            Toggle_RELAY(RELAY1)
            ' OR
            'Set_RELAY(RELAY1)
            ' Or
            'Clear_RELAY(RELAY1)

            If RELAY1_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "RELAY1 ON", CR
            Else
                HRSOut "RELAY1 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        If SW2_Fedge = 1 Then                   
            SW2_Fedge = 0                       ' Clear the bit when it is already read.
            HRSOut "Falling Detect SW2", CR

            'ClearRELWriteReadyFlag()
            'Toggle RELAY2                       ' Toggle the LED2 (Virtual pin) every time the SW2 is pressed.
            'WaitRELWriteReady()

            ' New command, samme as above.
            Toggle_RELAY(RELAY2)
            ' OR
            'Set_RELAY(RELAY2)
            ' Or
            'Clear_RELAY(RELAY2)

            If RELAY2_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "RELAY2 ON", CR
            Else
                HRSOut "RELAY2 OFF", CR
            EndIf
            HRSOut CR
        EndIf

        If SW3_Fedge = 1 Then                   
            SW3_Fedge = 0                       ' Clear the bit when it is already read.
            HRSOut "Falling Detect SW3", CR

            'ClearRELWriteReadyFlag()
            'Toggle RELAY3                         ' Toggle the LED3 (Virtual pin) every time the SW3 is pressed.
            'WaitRELWriteReady()

            ' New command, samme as above.
            Toggle_RELAY(RELAY3)
            ' OR
            'Set_RELAY(RELAY3)
            ' Or
            'Clear_RELAY(RELAY3)

            If RELAY3_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "RELAY3 ON", CR
            Else
                HRSOut "RELAY3 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        ' The events must to be clear by the user (bit by bit) after read it.
        ' Using the rising edge of the buttons. (see the schematic)
        ' Resistors pull-down to VSS
        If SW4_Redge = 1 Then                   
            SW4_Redge = 0                       ' Clear the bit when it is already read.
            HRSOut "Rising Detect SW4", CR

            'ClearWriteReadyFlag()
            'Toggle LED4                         ' Toggle the LED4 (Virtual pin) every time the SW4 is pressed.
            'WaitWriteReady()

            ' New command, samme as above.
            Toggle_LED(LED4)
            ' OR
            'Set_LED(LED4)
            ' Or
            'Clear_LED(LED4)

            If LED4_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "LED4 ON", CR
            Else
                HRSOut "LED4 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        If SW5_Redge = 1 Then                   
            SW5_Redge = 0                       ' Clear the bit when it is already read.
            HRSOut "Rising Detect SW5", CR

            'ClearWriteReadyFlag()
            'Toggle LED5                         ' Toggle the LED5 (Virtual pin) every time the SW5 is pressed.
            'WaitWriteReady()

            ' New command, samme as above.
            Toggle_LED(LED5)
            ' OR
            'Set_LED(LED5)
            ' Or
            'Clear_LED(LED5)

            If LED5_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "LED5 ON", CR
            Else
                HRSOut "LED5 OFF", CR
            EndIf
            HRSOut CR
        EndIf

        If SW6_Redge = 1 Then
            SW6_Redge = 0                       ' Clear the bit when it is already read.
            HRSOut "Rising Detect SW6", CR

            'ClearWriteReadyFlag()
            'Toggle LED6                         ' Toggle the LED6 (Virtual pin) every time the SW6 is pressed.
            'WaitWriteReady()

            ' New command, samme as above.
            Toggle_LED(LED6)
            ' OR
            'Set_LED(LED6)
            ' Or
            'Clear_LED(LED6)

            If LED6_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "LED6 ON", CR
            Else
                HRSOut "LED6 OFF", CR
            EndIf
            HRSOut CR
        EndIf            

        If SW7_Redge = 1 Then                   
            SW7_Redge = 0                       ' Clear the bit when it is already read.
            HRSOut "Rising Detect SW7", CR

            'ClearWriteReadyFlag()
            'Toggle LED7                         ' Toggle the LED7 (Virtual pin) every time the SW7 is pressed.
            'WaitWriteReady()

            ' New command, samme as above.
            Toggle_LED(LED7)
            ' OR
            'Set_LED(LED7)
            ' Or
            'Clear_LED(LED7)            

            If LED7_LAT = 1 Then                ' Read the real state of the PORT pin.
                HRSOut "LED7 ON", CR
                $ifdef WatchDog_On
                ' When the eeprom is written the global interrupt (GIE bit) is disabled (5mS x 2) = 10mS time.
                ClearWDTCounter()
                HRSOut "WATCHOG COUNTER CLEARED", CR
                $endif
            Else
                HRSOut "LED7 OFF", CR
            EndIf
            HRSOut CR
        EndIf                                    
        '-----------------------------------------------------------------------
        MyDelayMS(100)                          ' 100mS delay. The Delay must be multiple of 4mS.
    Wend
'===============================================================================
    Stop
'=============================================================================== 
'-------------------------------------------------------------------------------
$ifdef _HRSOutVersionFile_inc_
_ReadSyncWrite_bas_Version_: CData "Test2_ReadSyncWrite.bas Version 1.0 - 22/05/2016",0
$endif
'-------------------------------------------------------------------------------
'===============================================================================


